.TH "TXT2TAGS SAMPLE" 1 "03/19/2013" "Aurelio Jargas"

.P
This text is before the introduction.
.P
But it's OK.
.SH Introduction
.P
Welcome to the txt2tags sample file.
.P
Here you have examples and a brief explanation of all
marks.
.P
The first 3 lines of this file are used as headers,
on the following format:

.nf
line1: document title
line2: author name, email
line3: date, version
.fi


.P
Lines with balanced equal signs = around are titles.
.SH Fonts and Beautifiers
.P
We have two sets of fonts:
.P
The NORMAL type that can be improved with beautifiers.
.P
The TYPEWRITER type that uses monospaced font for
pre\-formatted text.
.P
We will now enter on a subtitle...
.SS Beautifiers
.P
The text marks for beautifiers are simple, just as you
type on a plain text email message.
.P
We use double *, /, \- and _ to represent \fBbold\fR,
\fIitalic\fR, strike and underline.
.P
The \fB\fIbold italic\fR\fR style is also supported as a
combination.
.SS Pre-Formatted Text
.P
We can put a code sample or other pre\-formatted text:

.nf
  here    is     pre-formatted
//marks// are  **not**  ``interpreted``
.fi


.P
And also, it's easy to put a one line pre\-formatted
text:

.nf
prompt$ ls /etc
.fi


.P
Or use pre\-formatted inside sentences.
.SS More Cosmetics
.P
Special entities like email (duh@somewhere.com) and
URL (http://www.duh.com) are detected automagically,
as long as the horizontal line:



.P
^ thin or large v



.P
You can also specify an explicit link (http://duh.org)
or an explicit email (duh@somewhere.com) with label.
.P
And remember,
.RS
A TAB in front of the line does a quotation.
.RS
More TABs, more depth (if allowed).
.RE
.RE
.P
Nice.
.SH Lists
.P
A list of items is natural, just putting a \fBdash\fR or
a \fBplus\fR at the beginning of the line.
.SS Plain List
.P
The dash is the default list identifier. For sublists,
just add \fBspaces\fR at the beginning of the line. More
spaces, more sublists.

.RS
.IP \(bu 3
Earth
.RS
.IP \(bu 3
America
.RS
.IP \(bu 3
South America
.RS
.IP \(bu 3
Brazil
.RS
.IP \(bu 3
How deep can I go?
.RE
.IP
.RE
.IP
.RE
.IP
.IP \(bu 3
Europe
.RS
.IP \(bu 3
Lots of countries
.RE
.IP
.RE
.IP
.IP \(bu 3
Mars
.RS
.IP \(bu 3
Who knows?
.RE
.IP
.RE
.IP

.P
The list ends with \fBtwo\fR consecutive blank lines.
.SS Numbered List
.P
The same rules as the plain list, just a different
identifier (plus).

.RS
.IP 1. 3
one
.IP 2. 3
two
.IP 3. 3
three
.RS
.IP \(bu 3
mixed lists!
.IP \(bu 3
what a mess
.RS
.IP 1. 3
counting again
.IP 2. 3
...
.RE
.IP
.RE
.IP
.IP 4. 3
four
.RE
.IP

.SS Definition List
.P
The definition list identifier is a colon, followed by
the term. The term contents is placed on the next line.

.TP
orange
a yellow fruit
.TP
apple
a green or red fruit
.TP
other fruits
.RS
.IP \(bu 3
wee!
.IP \(bu 3
mixing lists
.RS
.IP 1. 3
again!
.IP 2. 3
and again!
.RE
.IP
.RE
.IP

.SH Tables
.P
Use pipes to compose table rows and cells.
Double pipe at the line beginning starts a heading row.
Natural spaces specify each cell alignment.

.TS
center, allbox, tab(^); lcr.
 cell 1.1^cell 1.2^cell 1.3
 cell 2.1^cell 2.2^cell 2.3
 cell 3.1^cell 3.2^cell 3.3
.TE

.TS
allbox, tab(^); lcr.
 \fBheading 1\fR^\fBheading 2\fR^\fBheading 3\fR
 cell 1.1^cell 1.2^cell 1.3
 cell 2.1^cell 2.2^cell 2.3
.TE

.TS
center, allbox, tab(^); lcr.
 heading 1^cell 1.1^cell 1.2
 heading 2^cell 2.1^cell 2.2
 heading 3^cell 3.1^cell 3.2
.TE

.TS
allbox, tab(^); lcr.
 \fBheading\fR^\fBheading 1\fR^\fBheading 2\fR
 heading 1^cell 1.1^cell 1.2
 heading 2^cell 2.1^cell 2.2
.TE

.P
Without the last pipe, no border:

.TS
center, tab(^); lcr.
 cell 1.1^cell 1.2^cell 1.3
 cell 2.1^cell 2.2^cell 2.3
 cell 3.1^cell 3.2^cell 3.3
.TE

.TS
tab(^); lcr.
 \fBheading 1\fR^\fBheading 2\fR^\fBheading 3\fR
 cell 1.1^cell 1.2^cell 1.3
 cell 2.1^cell 2.2^cell 2.3
.TE

.TS
center, tab(^); lcr.
 heading 1^cell 1.1^cell 1.2
 heading 2^cell 2.1^cell 2.2
 heading 3^cell 3.1^cell 3.2
.TE

.TS
tab(^); lcr.
 \fBheading\fR^\fBheading 1\fR^\fBheading 2\fR
 heading 1^cell 1.1^cell 1.2
 heading 2^cell 2.1^cell 2.2
.TE

.SH Special Entities
.P
Because things were too simple.
.SS Images
.P
The image mark is as simple as it can be: [filename].
.P
                      img/photo.jpg  
.P
And with some targets the image is linkable :
.P
                      (img/photo.jpg) (http://www.txt2tags.org)  

.RS
.IP \(bu 3
The filename must end in PNG, JPG, GIF, or similar.
.IP \(bu 3
No spaces inside the brackets!
.RE
.IP

.SS Other
.P
When the target needs, special chars like <, > and &
are escaped.
.P
The handy %%date macro expands to the current date.
.P
So today is 20131001 on the ISO YYYYMMDD format.
.P
You can also specify the date format with the %? flags,
as %%date(%m\-%d\-%Y) which gives: 10\-01\-2013.
.P
That's all for now.



.P
img/t2tpowered.png (sample.t2t (sample.t2t))

.\" man code generated by txt2tags 2.6.1169 (http://txt2tags.org)
.\" cmdline: txt2tags -t man samples/sample.t2t
